#ifndef WHITE_LIST_H
#define WHITE_LIST_H

#include "list.h"

#include <sys/types.h>

typedef struct list_head white_list_t;

typedef struct {
    struct list_head list;
    u_int32_t addr;
}  white_list_cell_t;

void white_list_init(white_list_t *list);
void white_list_add(white_list_t *list, u_int32_t addr);
white_list_cell_t *white_list_find(white_list_t *list, u_int32_t addr);
void white_list_remove(white_list_t *list, u_int32_t addr);
void white_list_print(white_list_t *list);
void white_list_load(white_list_t *list, const char *filepath);
void white_list_save(white_list_t *list, const char *filepath);

#endif /* WHITE_LIST_H */
